﻿Imports System.ComponentModel

Namespace System.Windows.Forms

   Public Class GridAutoHeightBehavior
      Private WithEvents _List As IBindingList
      Private WithEvents _Grid As DataGridView
      Public Sub New(ByVal Grid As DataGridView)
         _Grid = Grid
         _Grid_DataSourceChanged(Nothing, Nothing)
      End Sub

      Private Sub _List_ListChanged(ByVal sender As Object, ByVal e As ListChangedEventArgs) Handles _List.ListChanged
         Select Case e.ListChangedType
            Case ListChangedType.Reset, ListChangedType.ItemAdded, ListChangedType.ItemDeleted
               BusyDelay.SetCallback(_AutoHeight)
         End Select
      End Sub

      Private Sub _Grid_DataSourceChanged(ByVal sender As Object, ByVal e As EventArgs) Handles _Grid.DataSourceChanged
         _List = Nothing
         If _Grid.DataSource Is Nothing Then Return
         _List = TryCast(_Grid.DataSource, IBindingList)
         If _List.Null Then Throw Me.Exception("DataSource ist keine IBindingList!")
         BusyDelay.SetCallback(_AutoHeight)
      End Sub

      Private _AutoHeight As Action = _
         Sub()
            With _Grid
               Dim cnt = DirectCast(.DataSource, IList).Count
               If .AllowUserToAddRows Then cnt += 1
               .Height = cnt * .RowTemplate.Height + .ColumnHeadersHeight + .BorderStyle * 2
            End With
         End Sub

      Private Sub _Grid_Disposed(ByVal sender As Object, ByVal e As EventArgs) Handles _Grid.Disposed
         BusyDelay.RemoveCallback(_AutoHeight)
         _Grid = Nothing
         _List = Nothing
      End Sub

   End Class

End Namespace