﻿Imports System.ComponentModel
Namespace System.Windows.Forms


   Public Class GridLockColumnBehavior

      Private WithEvents _Grid As DataGridView
      Private _nextCell As DataGridViewCell
      Private _runLeft As Boolean
      Private _byTab As Boolean

      <Description("defines the direction, where to look for an unlocked column first")> _
      Public Property FirstRunLeft As Boolean

      Public Sub New(ByVal Grid As DataGridView)
         _Grid = Grid
      End Sub

      Private Sub _Grid_CellEnter(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) Handles _Grid.CellEnter
         Dim x = e.ColumnIndex
         With _Grid
            If Not .Columns(x).ReadOnly Then
               _runLeft = FirstRunLeft
               Return
            End If
            Dim y = e.RowIndex
            Try
               Dim ext = _runLeft
               Do
                  If _runLeft Then
                     For x = x - 1 To 0 Step -1
                        If .Columns(x).Visible AndAlso Not .Columns(x).ReadOnly Then Return
                     Next
                  Else
                     For x = x + 1 To .ColumnCount - 1
                        If .Columns(x).Visible AndAlso Not .Columns(x).ReadOnly Then Return
                     Next
                  End If
                  If _byTab Then 'zeilenwechsel
                     If _runLeft Then
                        If y > 0 Then
                           y -= 1
                           x = .ColumnCount - 1
                           Continue Do
                        End If
                     Else
                        If y < .RowCount - 1 Then
                           y += 1
                           x = 0
                           Continue Do
                        End If
                     End If
                  End If
                  'nix gefunden - richtungswechsel
                  _runLeft = Not _runLeft
                  x = e.ColumnIndex
               Loop Until ext = _runLeft
            Finally
               _nextCell = .Item(x, y)
               If Not _nextCell.Visible Then Dim i = 9
               BusyDelay.SetCallback(Sub() .CurrentCell = _nextCell)
               _runLeft = FirstRunLeft
               _byTab = False
            End Try
         End With
      End Sub

      Private Sub _Grid_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles _Grid.KeyDown
         _byTab = e.KeyCode = Keys.Tab
         _runLeft = e.KeyData = (Keys.Tab Or Keys.Shift) OrElse e.KeyData = Keys.Left
      End Sub
   End Class

End Namespace